
package jforex;
import java.math.*;
import java.text.*;
import com.dukascopy.api.*;
import java.util.*;
import java.awt.Color;
import java.util.concurrent.TimeUnit;
public class PhantomJag03x implements IStrategy {
    
    
    /* Inputs borrowed from Mt4*/
    private boolean UseTradingHours = true;

    private int StartHour=7;
    private int FinishHour=19;
    private boolean   UsePipStep          =    true;
    private int    PipStep             =      20; // Pip Buffer before adding more trades to a pair        
    private boolean   CutLoserTrades      =    true;
    private double CutLoserMultiplier  =      1.5;
    private int ResetHourInterval = 8;
    private double ProfitPct=0.5;   
    private double MaxMarginToUse = 0.4;
    
    
    private static final Period PERIODSHR = Period.ONE_HOUR; // timeframe to add trades
    
	private IEngine engine;
	private IIndicators indicators;
	private IHistory history;
	private int tagCounter;
	private IConsole console;
	private IContext context;
	private double acctEquity=50000;

    private String LondonBuyPair1Phantom="GBPUSD";
    private String LondonBuyPair2Phantom="EURGBP";
    private String LondonBuyPair3Phantom="GBPJPY";
    private String LondonBuyPair4Phantom="USDCHF";
    private String LondonBuyPair5Phantom="NZDUSD";
    private String LondonBuyPair6Phantom="AUDJPY";
    private String LondonBuyPair7Phantom="EURJPY";

    private String LondonBuyPair1Real="EURJPY";
    private String LondonBuyPair2Real="GBPUSD";
    private String LondonBuyPair3Real="USDCHF";

    private String LondonSellPair1Phantom="EURUSD";
    private String LondonSellPair2Phantom="USDJPY";
    private String LondonSellPair3Phantom="AUDUSD";
    private String LondonSellPair4Phantom="NZDJPY";
    private String LondonSellPair5Phantom="GBPCHF";
    private String LondonSellPair6Phantom="CHFJPY";
    private String LondonSellPair7Phantom="EURCHF";
    
   
    private String LondonSellPair1Real="EURCHF";
    private String LondonSellPair2Real="CHFJPY";
    private String LondonSellPair3Real="GBPCHF";

    private double DollarProfitTarget = 0.0;
	private double valLastFlatEq = 0.0;
	private double BiggestPhantomWinnerPL = 0.0;
	private String BiggestPhantomWinnerType = "";
	private String BiggestPhantomWinnerSymbol = "";    
	private double lowestEquity = 50000d;
    private int EquityPopNum = 0;
	private boolean equityInUse;

	private double[] priceAskDaily = new double[Instrument.values().length];
    private double[] priceBidDaily = new double[Instrument.values().length];

                   
    private double[] PL_Phantom = new double[Instrument.values().length];

    private boolean PhantomsReset=false;
    private int PLCalculatedHour=0;
    private boolean CloseAll = true;
    private static final Filter indFilter = Filter.ALL_FLATS;
	private static final int SLIPPAGE = 5;
	private boolean clearPhantomWinner = false;
	
    private double lots = 0.01;

	
	// position management

    private static final String DATE_FORMAT_NOW = "yyyy/MM/dd_HH:mm";
    private double basketOpenTime;
    protected static Map<Currency, Instrument> pairs = new HashMap<Currency, Instrument>();
    private Currency accountCurrency;
    static {
       pairs.put(Currency.getInstance("AUD"), Instrument.AUDUSD);
       pairs.put(Currency.getInstance("CAD"), Instrument.USDCAD);
       pairs.put(Currency.getInstance("CHF"), Instrument.USDCHF);
       pairs.put(Currency.getInstance("DKK"), Instrument.USDDKK);
       pairs.put(Currency.getInstance("EUR"), Instrument.EURUSD);
       pairs.put(Currency.getInstance("GBP"), Instrument.GBPUSD);
       pairs.put(Currency.getInstance("HKD"), Instrument.USDHKD);
       pairs.put(Currency.getInstance("JPY"), Instrument.USDJPY);
       pairs.put(Currency.getInstance("MXN"), Instrument.USDMXN);
       pairs.put(Currency.getInstance("NOK"), Instrument.USDNOK);
       pairs.put(Currency.getInstance("NZD"), Instrument.NZDUSD);
       pairs.put(Currency.getInstance("SEK"), Instrument.USDSEK);
       pairs.put(Currency.getInstance("SGD"), Instrument.USDSGD);
       pairs.put(Currency.getInstance("TRY"), Instrument.USDTRY);
    }
	
	
	
    public boolean IsPhantomLong(String instrument)
    {
        
       if(instrument.equals(LondonBuyPair1Phantom)
        ||  instrument.equals(LondonBuyPair2Phantom)
        ||  instrument.equals(LondonBuyPair3Phantom)
        ||  instrument.equals(LondonBuyPair4Phantom)
        ||  instrument.equals(LondonBuyPair5Phantom)  
        ||  instrument.equals(LondonBuyPair6Phantom)
        ||  instrument.equals(LondonBuyPair7Phantom))
        return (true);
        else return(false);             
        
    }
    public boolean IsPhantomShort(String instrument)
    {
       
       if(instrument.equals(LondonSellPair1Phantom)
        ||  instrument.equals(LondonSellPair2Phantom)
        ||  instrument.equals(LondonSellPair3Phantom)
        ||  instrument.equals(LondonSellPair4Phantom)
        ||  instrument.equals(LondonSellPair5Phantom)  
        ||  instrument.equals(LondonSellPair6Phantom)
        ||  instrument.equals(LondonSellPair7Phantom)) 
        return (true);
        else return(false);               
    }
 //used for order label generation
    private String getCurrentTime(double time) {
             
        SimpleDateFormat sdf = new SimpleDateFormat(DATE_FORMAT_NOW);
        return sdf.format(time);
    }        
    // ** onBar used for entries **
    public void onBar(Instrument instrument, Period period, IBar askBar, IBar bidBar) throws JFException 
	{

         Calendar cal = Calendar.getInstance(TimeZone.getTimeZone("GMT"));
        cal.setTimeInMillis(askBar.getTime());     
        int hours = cal.get(Calendar.HOUR_OF_DAY);     
        int mins = cal.get(Calendar.MINUTE);             
        int week = cal.get(Calendar.WEEK_OF_YEAR);     
        int month = cal.get(Calendar.MONTH);      

        if (hours == ResetHourInterval && period == Period.ONE_HOUR){
           
         
            if(IsPhantomLong(instrument.name()) == true)
            {
                this.priceBidDaily[instrument.ordinal()] = bidBar.getOpen();
                 
            }
            else if(IsPhantomShort(instrument.name()) == true)
            {
                this.priceAskDaily[instrument.ordinal()] = askBar.getOpen();
                
            }
              
           
        }  

    
    
        if(period != PERIODSHR)
            return;      

                     
        if(PLCalculatedHour != hours)
        {
              
            PLCalculatedHour = hours;  
            this.BiggestPhantomWinnerPL = 0.0;        
            this.BiggestPhantomWinnerType = "";       
            this.BiggestPhantomWinnerSymbol = "";     
 
	       for (Instrument c : Instrument.values())
            {
		        if(IsPhantomLong(c.name()))
		            CalcPhantomPL(c, history.getLastTick(c), bidBar);       
		        if(IsPhantomShort(c.name()))
		            CalcPhantomPL(c, history.getLastTick(c), askBar); 
	        } 
               
               

         
                
        }    
          String instrumentTrading = "";
                  
           boolean isInstrumentLongPhantom = IsPhantomLong(instrument.name());
           boolean isInstrumentShortPhantom = IsPhantomShort(instrument.name());      
           boolean isInstrumentTrading = CheckTradeableSymbol(instrument.name(),askBar.getTime());                         
       IChart chart = context.getChart(instrument);
         if(isInstrumentLongPhantom)
             instrumentTrading = "BUY";
         else if(isInstrumentShortPhantom) 
             instrumentTrading = "Sell";
         if(isInstrumentTrading)
             instrumentTrading += "(Live)";
             
         if (chart != null) {
            DecimalFormat format = new DecimalFormat("0.00");
            chart.comment("This Phantom PL: " + format.format(this.PL_Phantom[instrument.ordinal()]) + "\n" +
            "This Phantom Type: " + instrumentTrading + "\n" + 
            "Biggest Phantom: " + this.BiggestPhantomWinnerSymbol+ "\n" +
            "Biggest Phantom Type: " + this.BiggestPhantomWinnerType+ "\n" +
            "Biggest Phantom PL: " + format.format(this.BiggestPhantomWinnerPL));
         }                      
        this.lots = (this.acctEquity*MaxMarginToUse/1000000.0) ;
        this.lots = roundLot(this.lots);

// *****   ENTRY SETUP   *******************************************************
	
            				
			if (BiggestPhantomWinnerSymbol.equals(instrument.name())  && 
           CheckTradeableSymbol(instrument.name(), bidBar.getTime()) == true  && AllSymbolTradesInProfit(instrument) == true )
			{   
                if (BiggestPhantomWinnerType.equals("BUY")  )
                {                                                                                                                                      
                    String label = getLabel(instrument);    
           
                        basketOpenTime = bidBar.getTime();                           
				        engine.submitOrder(label, instrument, IEngine.OrderCommand.BUY, this.lots, 0, SLIPPAGE,0, 0);	
				        print(getCurrentTime(bidBar.getTime()) + " - " + label + ": Long entry @: " + bidBar.getClose()  + " basket age:  " + ((bidBar.getTime()-basketOpenTime)/86400000) + " days,  lowest eq: "  + lowestEquity + " lots: " + lots);                   
                    
                }	
	            else if (BiggestPhantomWinnerType.equals("SELL") )
	            {
                    
	                String label = getLabel(instrument);
       
                        basketOpenTime = askBar.getTime();                                                      
	                     
			            engine.submitOrder(label, instrument, IEngine.OrderCommand.SELL, this.lots, 0, SLIPPAGE, 0, 0); 
			            print(getCurrentTime(askBar.getTime()) + " - " + label + ": Short entry @: " + askBar.getClose()   + " basket age:  " + ((askBar.getTime()-basketOpenTime)/86400000) + " days,  lowest eq: "  + lowestEquity + " lots: " + lots);
                  
	            }                	
			}
             this.clearPhantomWinner = true;
		}
       
    
	
    // ** onTICK: for open position management **
    public void onTick(Instrument instrument, ITick tick) throws JFException {
         Calendar cal = Calendar.getInstance(TimeZone.getTimeZone("GMT"));
        cal.setTimeInMillis(tick.getTime());     
        int hours = cal.get(Calendar.HOUR_OF_DAY);     
         int mins = cal.get(Calendar.MINUTE);   
         
         CloseBiggestLoser();   
        if (!this.CloseAll && this.valLastFlatEq != 0.0 &&  (this.acctEquity - this.valLastFlatEq) > this.DollarProfitTarget){
                this.valLastFlatEq = this.acctEquity;
                this.CloseAll = true;
                SetExitTargets();          
                basketOpenTime = 0;
                this.EquityPopNum++;
                print("Equity Pop #: " + this.EquityPopNum + " Profit Target: " +   this.DollarProfitTarget + " Equity: " + this.acctEquity + " lowest equity: " + lowestEquity );           
               
            }             
        

          
            
           if(this.CloseAll == true)
           {
               for (IOrder order : engine.getOrders()) 
               {
 
                order.close(); 
                 
               }               
            }    
// *****************************************************************************
    }
	
// *****  UTILS start  *********************************************************
   private double GetLowestOpenPrice(Instrument instrument) throws JFException
    {    
           double lowprice = 10000;
            for (IOrder order : engine.getOrders()) 
           {
               if(order.getState() == IOrder.State.FILLED && order.getInstrument() == instrument)
               {
                   double tempprice = order.getOpenPrice();
                   if(tempprice < lowprice)
                       lowprice = tempprice;
                  
               }
           }
           return(lowprice);
    }
   private double GetHighestOpenPrice(Instrument instrument) throws JFException
    {    
           double highprice = 0;
            for (IOrder order : engine.getOrders()) 
           {
               if(order.getState() == IOrder.State.FILLED && order.getInstrument() == instrument)
               {
                   double tempprice = order.getOpenPrice();
                   if(tempprice > highprice)
                       highprice = tempprice;
                  
               }
           }
           return(highprice);
    }
    private int CountOrders() throws JFException
    {    
           int count = 0;
            for (IOrder order : engine.getOrders()) 
           {
               if(order.getState() == IOrder.State.FILLED)
               {
                
                   count++;
               }
           }
           return(count);
    } 
    private void CloseBiggestLoser() throws JFException  
    {
        double biggestloser = 10000;
        
        for (IOrder order : engine.getOrders()) 
           {
               if(order.getState() == IOrder.State.FILLED)
               {
                   double profitloss = calculateProfitLoss(order);
                  if(profitloss < -DollarProfitTarget*CutLoserMultiplier)
                  {
                       order.close();
                       print("Closing loser: " + order.getInstrument().name() + " PL: " + profitloss);
                  }
               }  
          } 
         
       
    }
 
	private double roundLot(double lot)
	{	
		lot = (int)(lot * 1000) / (1000d);		// 1000 units min.
		return lot;
	}



	private double roundPip(double value) {
	// rounding to nearest half, 0, 0.5, or 1
		int pipsMultiplier = value <= 20 ? 10000 : 100;
		int rounded = (int) (value * pipsMultiplier * 10 + 0.5);
		rounded *= 2;
		rounded = (int) (((double) rounded) / 10d + 0.5d);
		value = ((double) rounded) / 2d;
		value /= pipsMultiplier;
		return value;
    }

    private String getLabel(Instrument instrument) throws JFException {
		int max = 0;
		int parse;
	
		// check for open position label numbers
		for (IOrder order : engine.getOrders(instrument)) {
			if (order.getState() == IOrder.State.FILLED) {
				parse = 0;
				try {
					parse = Integer.parseInt(order.getLabel().substring(6));
				}
				catch (NullPointerException e) {
					print(e.getMessage() + ": getLabel()");
					parse = 0;
				}
			
				if (parse > max) max = parse;
			}
		}
		if (max > tagCounter)		// continue count of existing number
			tagCounter = max;
			
        String label = instrument.name();
        label = label.substring(0, 3) + label.substring(3, 6);
        label = label + (tagCounter++);
        label = label.toLowerCase();
        return label;
   }
	
	public void print(String string) {
		this.console.getOut().println(string);
	}
	
	private void drawTrade(IOrder myOrder) {
		Instrument instrument;
		String label;
		boolean isLong;
		double openPrice, closePrice;
		IChart myChart;
		IChart.Type objType;
		IChartObject myObject;
		Color color;
	
		instrument = myOrder.getInstrument();
		isLong = myOrder.isLong();
		label = myOrder.getLabel();
		
		myChart = this.context.getChart(instrument);
		if (myChart == null)	return;		// no chart
		
		if (myOrder.getState() == IOrder.State.FILLED) 
		{
			objType = IChart.Type.PRICEMARKER;
			try {
				myObject = myChart.draw(label, objType, 
					myOrder.getFillTime(), myOrder.getOpenPrice());				
			} catch (NullPointerException e) {
				print(e.getMessage() + ": chart not available");
				return;
			}
			
			color = isLong ? Color.CYAN : Color.PINK;
		
			myObject.setColor(color);
		}
		else if (myOrder.getState() == IOrder.State.CLOSED) 
		{
			
			try {
				myChart.remove(label);			// remove entry marker
			} catch (NullPointerException e) {
				print(e.getMessage() + ": chart not available");
				return;
			}			
		
			objType = IChart.Type.SHORT_LINE;
			openPrice = myOrder.getOpenPrice();
			closePrice = myOrder.getClosePrice();
			try {
				myObject = myChart.draw(label, objType, 
					myOrder.getFillTime(), openPrice,
					myOrder.getCloseTime(), closePrice);			
			} catch (NullPointerException e) {
				print(e.getMessage() + ": chart not available");
				return;
			}
			
			if (isLong) {
				color = openPrice < closePrice ? Color.BLUE : Color.RED;
			}
			else {
				color = openPrice > closePrice ? Color.BLUE : Color.RED;
			}
			
			myObject.setColor(color);
			//myObject.setAttrInt(IChartObject.ATTR_INT.WIDTH, 1);
		}
	
	
	}



// *****  API  ****************************************************************
	public void onStart(IContext context) throws JFException {
		this.engine = context.getEngine();
		this.indicators = context.getIndicators();
		this.history = context.getHistory();
		this.console = context.getConsole();	// allows printing to console
		this.context = context;
		
		Set instSet;
		instSet = context.getSubscribedInstruments();
		Iterator instIter = instSet.iterator();
		IBar prevBidBar, prevAskBar;
		Instrument instrument;
		
		this.console.getOut().print("--- Started: ");
		this.console.getOut().print(Instrument.toStringSet(instSet));
		print(" ---");
		init();
		
		
		for (IOrder order : this.engine.getOrders()) 
		{
			 drawTrade(order);
		}

	}
	
	// Represents message sent from server to client application 
	public void onMessage(IMessage message) throws JFException {
		IMessage.Type msgType = message.getType();
		IOrder order = message.getOrder();
		
		// Draw trades on the chart
		if (msgType == IMessage.Type.ORDER_FILL_OK ||
			msgType == IMessage.Type.ORDER_CLOSE_OK) 
		{
			drawTrade(order);
		}
		
    }
	
   public void onAccount(IAccount account) throws JFException {
        this.accountCurrency = account.getCurrency();
		this.acctEquity = account.getEquity();
        if(this.acctEquity < lowestEquity)
            lowestEquity = this.acctEquity;
  	
        if(account.getUseOfLeverage() == 0)
        {
            this.equityInUse = false;
            //if(account.getEquity() >= this.valLastFlatEq)
			    this.valLastFlatEq = account.getEquity();
			lowestEquity = account.getEquity();		
            this.CloseAll = false;
        }
        else
            this.equityInUse = true;

	}
	
	public void onStop() throws JFException {
		for (IOrder order : engine.getOrders()) 
		{	// loop all orders
			// close non-strategy orders, i.e. margin hedging		
			if (order.getLabel() == "") order.close();				
		}			

		print("---Stopped---");
   }

	public void ResetPhantoms() throws JFException {
	
		
        this.BiggestPhantomWinnerPL = 0.0;        
        this.BiggestPhantomWinnerType = "";       
        this.BiggestPhantomWinnerSymbol = "";		
	
	
	
	}
	public void init() throws JFException {
	
		
		
		this.valLastFlatEq = this.acctEquity;
        SetExitTargets();
		
	
	}  
    


    

	public void SetExitTargets() throws JFException {
 	
		this.DollarProfitTarget = this.valLastFlatEq*(ProfitPct/100);
		
	

	
	}
  private double calculateProfitLoss(IOrder order) throws JFException {
      double closePrice;
      if (order.getState() == IOrder.State.CLOSED) {
         closePrice = order.getClosePrice();
      } else {
         ITick tick = history.getLastTick(order.getInstrument());
         if (order.getOrderCommand().isLong()) {
            closePrice = tick.getBid();
         } else {
            closePrice = tick.getAsk();
         }
      }
        BigDecimal profLossInSecondaryCCY;
        if (order.getOrderCommand().isLong()) {
            profLossInSecondaryCCY = BigDecimal.valueOf(closePrice).subtract(BigDecimal.valueOf(order.getOpenPrice()))
                    .multiply(BigDecimal.valueOf(order.getAmount()).multiply(BigDecimal.valueOf(1000000))).setScale(2, BigDecimal.ROUND_HALF_EVEN);
        } else {
            profLossInSecondaryCCY = BigDecimal.valueOf(order.getOpenPrice()).subtract(BigDecimal.valueOf(closePrice))
                    .multiply(BigDecimal.valueOf(order.getAmount()).multiply(BigDecimal.valueOf(1000000))).setScale(2, BigDecimal.ROUND_HALF_EVEN);
        }
        OfferSide side = order.getOrderCommand().isLong() ? OfferSide.ASK : OfferSide.BID;
        BigDecimal convertedProfLoss = convert(profLossInSecondaryCCY, order.getInstrument().getSecondaryCurrency(),
                accountCurrency, side).setScale(2, BigDecimal.ROUND_HALF_EVEN);
        return convertedProfLoss.doubleValue();
   }
   
   private double calculateProfitLoss(Instrument instrumentToCalculate, ITick tick, double referencePrice, boolean isLong, IBar bar) throws JFException {
     
      double openPrice = referencePrice;
       double closePrice = openPrice;
        
        if(isLong)
            closePrice = tick.getBid();
        else
            closePrice = tick.getAsk();
        if(closePrice <= 0)
            closePrice = bar.getClose();
        BigDecimal profLossInSecondaryCCY;
        if (isLong) {
            profLossInSecondaryCCY = BigDecimal.valueOf(closePrice).subtract(BigDecimal.valueOf(openPrice))
                    .multiply(BigDecimal.valueOf(100000)).setScale(2, BigDecimal.ROUND_HALF_EVEN);
        } else {
            profLossInSecondaryCCY = BigDecimal.valueOf(openPrice).subtract(BigDecimal.valueOf(closePrice))
                    .multiply(BigDecimal.valueOf(100000)).setScale(2, BigDecimal.ROUND_HALF_EVEN);
        }
        OfferSide side = isLong? OfferSide.ASK : OfferSide.BID;
        BigDecimal convertedProfLoss = convert(profLossInSecondaryCCY, instrumentToCalculate.getSecondaryCurrency(),
                accountCurrency, side).setScale(2, BigDecimal.ROUND_HALF_EVEN);
        //print("symbol: " + instrumentToCalculate.name() + " openPrice: " + openPrice + " closeprice: " + closePrice + " pl: " + convertedProfLoss.doubleValue());
        return convertedProfLoss.doubleValue();
   }
   
    public BigDecimal convert(BigDecimal amount, Currency sourceCurrency, Currency targetCurrency, OfferSide side) throws JFException {
        if (targetCurrency.equals(sourceCurrency)) {
            return amount;
        }
   
        BigDecimal dollarValue;
        if (sourceCurrency.equals(Instrument.EURUSD.getSecondaryCurrency())) {
            dollarValue = amount;
        } else {
            Instrument helperSourceCurrencyPair = pairs.get(sourceCurrency);
            if (helperSourceCurrencyPair == null) {
                throw new IllegalArgumentException("No currency pair found for " + sourceCurrency);
            }
   
            BigDecimal helperSourceCurrencyPrice = getLastPrice(helperSourceCurrencyPair, side);
           if (null == helperSourceCurrencyPrice) return null;
   
            dollarValue = helperSourceCurrencyPair.toString().indexOf("USD") == 0 ?
                    amount.divide(helperSourceCurrencyPrice, 2, RoundingMode.HALF_EVEN)
                    : amount.multiply(helperSourceCurrencyPrice).setScale(2, RoundingMode.HALF_EVEN);
        }
   
        if (targetCurrency.equals(Instrument.EURUSD.getSecondaryCurrency())) {
            return dollarValue;
        }
   
        Instrument pair = pairs.get(targetCurrency);
        BigDecimal price = getLastPrice(pair, side);
        if (null == price) return null;
       
        BigDecimal result = pair.toString().indexOf("USD") == 0 ?
                dollarValue.multiply(price).setScale(2, RoundingMode.HALF_EVEN)
                : dollarValue.divide(price, 2, RoundingMode.HALF_EVEN);
   
        return result;
    }
   
    protected BigDecimal getLastPrice(Instrument pair, OfferSide side) throws JFException {
      ITick tick = history.getLastTick(pair);
      if (tick == null) {
         return null;
      }
      if (side == OfferSide.BID) {
         return BigDecimal.valueOf(tick.getBid());
      } else {
         return BigDecimal.valueOf(tick.getAsk());
      }
    }
	public void CalcPhantomPL(Instrument instrument, ITick tick, IBar bar) throws JFException {
		int i=0;
       
      
        boolean isInstrumentLongPhantom = false;
        boolean isInstrumentShortPhantom = false;        

        double profitLossInAccountCurrency = 0;
  
 
                
         isInstrumentLongPhantom = IsPhantomLong(instrument.name());
         isInstrumentShortPhantom = IsPhantomShort(instrument.name());
        
                     
        if(isInstrumentLongPhantom &&this.priceBidDaily[instrument.ordinal()] != 0)
        {
           profitLossInAccountCurrency = calculateProfitLoss(instrument, tick, this.priceBidDaily[instrument.ordinal()], true, bar) ;
           this.PL_Phantom[instrument.ordinal()] = profitLossInAccountCurrency;
           
            if (this.PL_Phantom[instrument.ordinal()] > this.BiggestPhantomWinnerPL){
                 
                    this.BiggestPhantomWinnerPL = this.PL_Phantom[instrument.ordinal()];
                    
                    this.BiggestPhantomWinnerType = "BUY";
                    
                    this.BiggestPhantomWinnerSymbol = instrument.name();
             }         
        }
        if(isInstrumentShortPhantom && this.priceAskDaily[instrument.ordinal()] != 0  )
        {
           profitLossInAccountCurrency = calculateProfitLoss(instrument, tick,  this.priceAskDaily[instrument.ordinal()], false, bar); 
           this.PL_Phantom[instrument.ordinal()] = profitLossInAccountCurrency;
            if (this.PL_Phantom[instrument.ordinal()]  > this.BiggestPhantomWinnerPL){
                     
                    this.BiggestPhantomWinnerPL = this.PL_Phantom[instrument.ordinal()];
                    
                    this.BiggestPhantomWinnerType = "SELL";
                    
                    this.BiggestPhantomWinnerSymbol = instrument.name();
             }         
        }        
		

		
	
	}
   
    public boolean CheckTradeableSymbol(String symbol, long time) throws JFException
	{
	
        Calendar cal = Calendar.getInstance(TimeZone.getTimeZone("GMT"));
        cal.setTimeInMillis(time);     
        int hours = cal.get(Calendar.HOUR_OF_DAY);    
        int day = cal.get(Calendar.DAY_OF_WEEK);    
        //print("day: " + day);
        // trade during session hours only or if trade already in progress then trade around the clock
	     if(/*day <= 5 && day > 1 && */((hours >= StartHour && hours < FinishHour && UseTradingHours) || !UseTradingHours)) 
	     {
	         if(symbol.equals(LondonBuyPair1Real) || symbol.equals(LondonBuyPair2Real)  || symbol.equals(LondonBuyPair3Real) || 
	            symbol.equals(LondonSellPair1Real) || symbol.equals(LondonSellPair2Real) || symbol.equals(LondonSellPair3Real))
	            return (true);
	     } 


	  return (false);
	}	
    public boolean AllSymbolTradesInProfit(Instrument instrument) throws JFException
    {
       
    double pipthres = 0;
    if(UsePipStep)
        pipthres = PipStep;
        for (IOrder order : this.engine.getOrders(instrument)) {
            if (order.getState() == IOrder.State.FILLED) {
                
                
               if(order.getProfitLossInUSD() < pipthres)
                   return (false);
           
            }
        }   
        return (true);     
    }
  }        

    